<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Puntos de Venta</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">Puntos de Venta</div>
      <br />
      <div class="gris">
        <v-row>
          <v-col class="pb-sm-0" :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            <div class="CampoOblogario">
              Punto de Venta
              <span class="tRojo">*</span>
            </div>
            <v-autocomplete
              v-model="searchPuntoContacto"
              :loading="isSearching"
              :items="metadata.puntosContacto"
              :search-input.sync="searchPuntoContactoSync"
              clearable
              hide-no-data
              hide-details
              hide-selected
              item-text="puntoContacto_descripcion"
              item-value="puntoContacto"
              @change="irPuntoVenta()"
              placeholder="Escribe el nombre o ceco del Punto de Venta"
              label="Buscar Punto de Venta"
              solo
              return-object
            />
          </v-col>
          <!--<v-col class="pt-sm-0" :cols="12" :sm="12" :md="4" :lg="3" :xl="2">
            <v-btn
              block
              class="mr-6 mt-md-3 mt-sm-0"
              depressed
              dark
              tile
              color="secundary"
              :class="[
                { desac: isLoadingPuntoContacto || !searchPuntoContacto }
              ]"
              @click="getPuntoContacto()"
              >Buscar Punto de Venta</v-btn
            >
          </v-col>-->
        </v-row>
      </div>

      <template v-if="!isNoActivePuntoContacto || isPuntoContactoAsignado">
        <div class="titSec" v-show="infoPuntoContactoResult">
          Asignación de la franquicia
        </div>
        <div class="CampoOblogario" v-show="infoPuntoContactoResult">
          Campo requerido
          <span class="tRojo">*</span>
        </div>
      </template>
    </div>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import axios from "axios";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-buscadorPuntoContacto",
  components: {},
  data() {
    return {
      serviceCommons,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Revisión en Sitio",
          disabled: true,
        },
        {
          text: "Buscadores",
          disabled: true,
        },
        {
          text: "Por Punto de Venta",
          disabled: true,
        },
      ],
      searchPuntoContacto: null,
      searchPuntoContactoSync: null,
      metadata: {
        puntosContacto: [],
        franquicias: [],
        categoriasFranquicia: [],
        modelosFranquicia: [],
        formatosFranquicia: [],
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      //isLoadingPuntoContacto: false,
      isLoadingFranquicia: false,
      isDialogErrorValidation: false,
      isDialogSave: false,
      isDialogCancel: false,
      isNotFoundPuntoContacto: false,
      isNoActivePuntoContacto: false,
      isSavingAsignacion: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      puntoContacto: {
        punto_contacto: null,
        //   nombre_gerente: null,
      },
    };
  },

  watch: {
    searchPuntoContactoSync(val) {
      if (!val) {
        this.searchGerente = null;
        this.invokeDefaultEmpyDataPuntoContacto();
      }
    },
  },
  computed: {},
  methods: {
    getPuntosContacto() {
      var self = this;
      self.isLoadingPuntosContacto = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/ceco")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setPuntosContacto(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingPuntosContacto = false;
        });
    },
    setPuntosContacto(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.puntoContacto_descripcion =
            item.id_ceco + " - " + item.punto_contacto;
          return item;
        });
      }
      this.metadata.puntosContacto = data;
    },

    snapshotDataPuntoContacto() {
      let puntoContacto = JSON.stringify(this.puntoContacto);
      this.defaultDataPuntoContacto = JSON.parse(puntoContacto);
    },
    invokeDefaultEmpyDataPuntoContacto() {
      let puntoContacto = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.puntoContacto = puntoContacto;
      this.$v.$reset();
    },

    irPuntoVenta() {
      if (this.searchPuntoContacto) {
        this.$router.push({
          name: "certificacion_calidad_pv_ultima_certificacion",
          params: {
            puntoVenta: serviceCommons.objectToBase64(this.searchPuntoContacto),
          },
        });
      }
    },
  },
  created() {
    this.snapshotDataPuntoContacto();
    this.getPuntosContacto();
  },
};
</script>
